{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module AbstractCurry.Curry_Files
  ( nd_C_readCurry
  , nd_C_readCurryWithImports
  , nd_C_tryReadCurryWithImports
  , nd_C_tryReadCurryFile
  , nd_C_tryParse
  , nd_C_readUntypedCurry
  , nd_C_readCurryWithParseOptions
  , nd_C_readUntypedCurryWithParseOptions
  , d_C_abstractCurryFileName
  , d_C_untypedAbstractCurryFileName
  , nd_C_readAbstractCurryFile
  , nd_C_tryReadACYFile
  , nd_C_writeAbstractCurryFile )
  where

import Basics
import qualified AbstractCurry.Curry_Select
import qualified AbstractCurry.Curry_Types
import qualified Data.Curry_Char
import qualified Data.Curry_Time
import qualified Curry_Prelude
import qualified Curry_ReadShowTerm
import qualified System.Curry_CurryPath
import qualified System.Curry_Directory
import qualified System.Curry_FilePath
import qualified System.Curry_FrontendExec


nd_C_readCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_C_readCurry x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_readCurryWithParseOptions x1
  (System.Curry_FrontendExec.d_C_setQuiet Curry_Prelude.C_True
  (System.Curry_FrontendExec.d_C_defaultParams cd cs) cd cs) s0 cd cs

nd_C_readCurryWithImports :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg)
nd_C_readCurryWithImports x1 s cd cs = let s0 = s
  in s0 `seq` nd_OP_readCurryWithImports_dot_collect_dot_4 Curry_Prelude.OP_List
  (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List) s0 cd cs

nd_OP_readCurryWithImports_dot_collect_dot_4 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_readCurryWithImports_dot_collect_dot_4 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) Curry_Prelude.OP_List s1 cd cs))
  Curry_Prelude.OP_Cons x3 x4 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_20 x1 x3 x4 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_elem
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)))
    x3 s0 cd cs) x1 s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_readCurryWithImports_dot_collect_dot_4 x1 l s cd cs)
    (nd_OP_readCurryWithImports_dot_collect_dot_4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_readCurryWithImports_dot_collect_dot_4 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (nd_OP_readCurryWithImports_dot_collect_dot_4 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files.readCurryWithImports.collect.4" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readCurryWithImports.collect.4" (showCons x2))

nd_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CurryProg -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda3 x1 x2 x3 x4 s cd cs =
  let s6 = s
  in s6 `seq` (let x5 = x4
  in let s5 = leftSupply s6
         s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (nd_OP_readCurryWithImports_dot_collect_dot_4 (Curry_Prelude.OP_Cons
  x1 x2) (Curry_Prelude.d_OP_plus_plus x3
  (AbstractCurry.Curry_Select.d_C_imports x5 cd cs) cd cs) s1 cd cs) s2 cd
  cs)))) (wrapDX id
  (d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5
  x5)) s5 cd cs))

d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 :: AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Curry_Prelude.OP_Cons x1 x3) cd cs

nd_C_tryReadCurryWithImports :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
nd_C_tryReadCurryWithImports x1 s cd cs = let s0 = s
  in s0 `seq` nd_OP_tryReadCurryWithImports_dot_collect_dot_13
  Curry_Prelude.OP_List (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List) s0 cd
  cs

nd_OP_tryReadCurryWithImports_dot_collect_dot_13 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg))
nd_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (Curry_Prelude.C_Right Curry_Prelude.OP_List) s1 cd cs))
  Curry_Prelude.OP_Cons x3 x4 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_18 x1 x3 x4 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_elem
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)))
    x3 s0 cd cs) x1 s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 l s cd cs)
    (nd_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (nd_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13" (showCons x2))

nd_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CurryProg))
nd_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8 x1 x2 x3 x4 s cd cs =
  case x4 of
  Curry_Prelude.C_Left x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (Curry_Prelude.C_Left (Curry_Prelude.OP_Cons x5
    Curry_Prelude.OP_List)) s1 cd cs))
  Curry_Prelude.C_Right x6 -> let s0 = s
    in s0 `seq` nd_C__case_16 x3 x2 x1 x6 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i
    (nd_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8 x1
    x2 x3 l s cd cs)
    (nd_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8 x1
    x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8 x1
    x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c
    (nd_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8 x1
    x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13._#lambda8" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryWithImports.collect.13._#lambda8" (showCons
    x4))

d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12 :: AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Curry_Prelude.d_C_either (acceptCs id Curry_Prelude.C_Left)
  (Curry_Prelude.d_OP_dot (acceptCs id Curry_Prelude.C_Right) (acceptCs id
  (Curry_Prelude.OP_Cons x1)) cd cs) x3 cd cs) cd cs

nd_C_tryReadCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C_tryReadCurryFile x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (System.Curry_CurryPath.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  s1 cd cs)) (wrapNX id (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15 x1)) s3
  cd cs))

d_OP_tryReadCurryFile_dot_cancel_dot_33 :: forall t0 t1
  t2 . (forall x0 . (Curry_Prelude.Curry x0) => Curry_Prelude.Curry
  (Curry_Prelude.C_Apply t1 x0), Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t1) -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t1 (Curry_Prelude.C_Either t2 t0)
d_OP_tryReadCurryFile_dot_cancel_dot_33 x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_return x1 cd cs) (Curry_Prelude.C_Left x2) cd cs

nd_OP_tryReadCurryFile_dot_cancel_dot_33 :: forall t0 t1
  t2 . (forall x0 . (Curry_Prelude.Curry x0) => Curry_Prelude.Curry
  (Curry_Prelude.C_Apply t1 x0), Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Monad t1)
  -> t2 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Apply t1
  (Curry_Prelude.C_Either t2 t0)
nd_OP_tryReadCurryFile_dot_cancel_dot_33 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_return x1
  s0 cd cs) (Curry_Prelude.C_Left x2) s1 cd cs))

nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (nd_OP_tryReadCurryFile_dot_cancel_dot_33 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Source module '") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "' not found") cd cs) cd cs) s0 cd cs
  Curry_Prelude.C_Just x3 -> let s0 = s in s0 `seq` nd_C__case_15 x1 x3 s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15 x1 l s cd cs)
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15 x1 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda15" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Files.tryReadCurryFile._#lambda15"
    (showCons x2))

nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19 x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (nd_OP_tryReadCurryFile_dot_cancel_dot_33 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry module '") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "' not found") cd cs) cd cs) s0 cd cs
  Curry_Prelude.C_Just x4 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_Directory.d_C_getModificationTime x2 cd cs) s1 cd
    cs)) (wrapNX id
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24
    x4 x2)) s3 cd cs))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19 x1
    x2 l s cd cs)
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19 x1
    x2 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19 x1
    x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda15._#lambda19" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda15._#lambda19" (showCons x3))

nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Data.Curry_Time.C_ClockTime -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24 x1 x2 x3 s cd cs =
  let s4 = s
  in s4 `seq` (let x4 = x3
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (System.Curry_Directory.d_C_getModificationTime x1 cd cs) s1 cd cs))
  (wrapNX id
  (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
  x4 x1 x2)) s3 cd cs))

nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26 :: Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Data.Curry_Time.C_ClockTime -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26 x1 x2 x3 x4 s cd cs =
  let s4 = s
  in s4 `seq` (let x5 = x4
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C__case_14 x5 x1 x2 x3 (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Data.Curry_Time.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Data_dot_Time_dot_ClockTime
  cd cs)) x1 s0 cd cs) x5 s1 cd cs)) s3 cd cs))

d_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29 :: Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29 x1 cd cs =
  case x1 of
  Curry_Prelude.C_Left x2 -> d_OP_tryReadCurryFile_dot_cancel_dot_33
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO x2
    cd cs
  Curry_Prelude.C_Right x3 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (Curry_Prelude.C_Right x3) cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29
    l cd cs)
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29
    r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z ->
    d_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29
    z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c
    (d_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda15._#lambda19._#lambda24._#lambda26._#lambda29"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadCurryFile._#lambda15._#lambda19._#lambda24._#lambda26._#lambda29"
    (showCons x1))

nd_C_tryParse :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C_tryParse x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (System.Curry_Directory.d_C_doesFileExist x1 cd cs) s1 cd cs))
  (wrapNX id (nd_OP_tryParse_dot_uscore_hash_lambda33 x1)) s3 cd cs))

d_OP_tryParse_dot_cancel_dot_55 :: forall t0 t1
  t2 . (forall x0 . (Curry_Prelude.Curry x0) => Curry_Prelude.Curry
  (Curry_Prelude.C_Apply t1 x0), Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t1) -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t1 (Curry_Prelude.C_Either t2 t0)
d_OP_tryParse_dot_cancel_dot_55 x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_return x1 cd cs) (Curry_Prelude.C_Left x2) cd cs

nd_OP_tryParse_dot_cancel_dot_55 :: forall t0 t1
  t2 . (forall x0 . (Curry_Prelude.Curry x0) => Curry_Prelude.Curry
  (Curry_Prelude.C_Apply t1 x0), Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Monad t1)
  -> t2 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Apply t1
  (Curry_Prelude.C_Either t2 t0)
nd_OP_tryParse_dot_cancel_dot_55 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_return x1
  s0 cd cs) (Curry_Prelude.C_Left x2) s1 cd cs))

nd_OP_tryParse_dot_uscore_hash_lambda33 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryParse_dot_uscore_hash_lambda33 x1 x2 s cd cs = let s0 = s
  in s0 `seq` (let x3 = x2
  in nd_C__case_13 x3 x1 (Curry_Prelude.d_C_not x3 cd cs) s0 cd cs)

nd_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36 x1 x2 s cd cs =
  let s10 = s
  in s10 `seq` (let s2 = leftSupply s10
                    s9 = rightSupply s10
  in s2 `seq` (s9 `seq` (let x3 = x2
                             x4 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_break (wrapNX id
                               (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                               (acceptCs id
                               Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char))
                               (Curry_Prelude.C_Char '\n'#))) s0 cd cs) x3 s1 cd
                               cs)
                             x5 = d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP2_hash_line1
                               x4 cd cs
                             x6 = d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP3_hash_lines
                               x4 cd cs
  in let s8 = leftSupply s9
         s7 = rightSupply s9
  in s8 `seq` (s7 `seq` nd_C__case_12 x5 x6 x1 (let s6 = leftSupply s7
                                                    s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char) s3
  cd cs) x5 s4 cd cs)) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "{- ") (Curry_Prelude.d_OP_plus_plus
  (AbstractCurry.Curry_Types.d_C_version cd cs) (Curry_Prelude.toCurryString
  " -}") cd cs) cd cs) s6 cd cs)) s8 cd cs))))

d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP2_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP2_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP2_hash_line1
    l cd cs)
    (d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP2_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP2_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP2_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryParse._#lambda33._#lambda36._#selFP2#line1" [show
    x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryParse._#lambda33._#lambda36._#selFP2#line1"
    (showCons x1))

d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP3_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP3_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP3_hash_lines
    l cd cs)
    (d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP3_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP3_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36_dot_uscore_hash_selFP3_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryParse._#lambda33._#lambda36._#selFP3#lines" [show
    x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryParse._#lambda33._#lambda36._#selFP3#lines"
    (showCons x1))

nd_C_readUntypedCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_C_readUntypedCurry x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_readUntypedCurryWithParseOptions x1
  (System.Curry_FrontendExec.d_C_setQuiet Curry_Prelude.C_True
  (System.Curry_FrontendExec.d_C_defaultParams cd cs) cd cs) s0 cd cs

nd_C_readCurryWithParseOptions :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> System.Curry_FrontendExec.C_FrontendParams -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
nd_C_readCurryWithParseOptions x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s0 = leftSupply s6
                   s5 = rightSupply s6
  in s0 `seq` (s5 `seq` (let x3 = Curry_Prelude.nd_C_apply (wrapDX id
                               (System.Curry_FilePath.d_C_takeFileName cd cs))
                               x1 s0 cd cs
  in let s4 = leftSupply s5
         s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s1 cd cs) (System.Curry_CurryPath.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  s2 cd cs)) (wrapNX id
  (nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41 x2 x3 x1)) s4 cd
  cs))))

nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41 :: System.Curry_FrontendExec.C_FrontendParams
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41 x1 x2 x3 x4 s cd cs =
  case x4 of
  Curry_Prelude.C_Nothing -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_CurryPath.d_C_getLoadPathForModule x3 cd cs) s1 cd
    cs)) (wrapNX id
    (nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41_dot_uscore_hash_lambda46
    x2)) s3 cd cs))
  Curry_Prelude.C_Just x5 -> let s0 = s
    in s0 `seq` nd_C__case_7 x2 x3 x1 x5 s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41 x1 x2 x3 l s cd
    cs) (nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41 x1 x2 x3 r s
    cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41 x1 x2 x3 z s cd cs)
    xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41 x1 x2 x3 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.readCurryWithParseOptions._#lambda41" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readCurryWithParseOptions._#lambda41" (showCons x4))

nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41_dot_uscore_hash_lambda46 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41_dot_uscore_hash_lambda46 x1 x2 s cd cs =
  let s4 = s
  in s4 `seq` (let x3 = x2
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (System.Curry_Directory.d_C_getFileWithSuffix
  (d_C_abstractCurryFileName x1 cd cs) (Curry_Prelude.OP_Cons
  Curry_Prelude.OP_List Curry_Prelude.OP_List) x3 cd cs) s1 cd cs)) (wrapNX id
  nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41_dot_uscore_hash_lambda46_dot_uscore_hash_lambda48)
  s3 cd cs))

nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41_dot_uscore_hash_lambda46_dot_uscore_hash_lambda48 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readCurryWithParseOptions_dot_uscore_hash_lambda41_dot_uscore_hash_lambda46_dot_uscore_hash_lambda48 x1 s cd cs =
  let s0 = s in s0 `seq` (let x2 = x1 in nd_C_readAbstractCurryFile x2 s0 cd cs)

nd_C_readUntypedCurryWithParseOptions :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> System.Curry_FrontendExec.C_FrontendParams -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_C_readUntypedCurryWithParseOptions x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s0 = leftSupply s6
                   s5 = rightSupply s6
  in s0 `seq` (s5 `seq` (let x3 = Curry_Prelude.nd_C_apply (wrapDX id
                               (System.Curry_FilePath.d_C_takeFileName cd cs))
                               x1 s0 cd cs
  in let s4 = leftSupply s5
         s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s1 cd cs) (System.Curry_CurryPath.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  s2 cd cs)) (wrapNX id
  (nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51 x2 x3 x1)) s4
  cd cs))))

nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51 :: System.Curry_FrontendExec.C_FrontendParams
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51 x1 x2 x3 x4 s cd cs =
  case x4 of
  Curry_Prelude.C_Nothing -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_CurryPath.d_C_getLoadPathForModule x3 cd cs) s1 cd
    cs)) (wrapNX id
    (nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51_dot_uscore_hash_lambda56
    x2)) s3 cd cs))
  Curry_Prelude.C_Just x5 -> let s0 = s
    in s0 `seq` nd_C__case_6 x2 x3 x1 x5 s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51 x1 x2 x3 l
    s cd cs) (nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51 x1
    x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51 x1 x2 x3 z s
    cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51 x1 x2 x3 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Files.readUntypedCurryWithParseOptions._#lambda51" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readUntypedCurryWithParseOptions._#lambda51" (showCons
    x4))

nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51_dot_uscore_hash_lambda56 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51_dot_uscore_hash_lambda56 x1 x2 s cd cs =
  let s4 = s
  in s4 `seq` (let x3 = x2
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (System.Curry_Directory.d_C_getFileWithSuffix
  (d_C_untypedAbstractCurryFileName x1 cd cs) (Curry_Prelude.OP_Cons
  Curry_Prelude.OP_List Curry_Prelude.OP_List) x3 cd cs) s1 cd cs)) (wrapNX id
  nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58)
  s3 cd cs))

nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda51_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58 x1 s cd cs =
  let s0 = s in s0 `seq` (let x2 = x1 in nd_C_readAbstractCurryFile x2 s0 cd cs)

d_C_abstractCurryFileName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_abstractCurryFileName x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (System.Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (System.Curry_CurryPath.d_C_inCurrySubdir
  (System.Curry_CurryPath.d_C_stripCurrySuffix x1 cd cs) cd cs) cd cs)
  (Curry_Prelude.toCurryString "acy") cd cs

d_C_untypedAbstractCurryFileName :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_untypedAbstractCurryFileName x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (System.Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (System.Curry_CurryPath.d_C_inCurrySubdir
  (System.Curry_CurryPath.d_C_stripCurrySuffix x1 cd cs) cd cs) cd cs)
  (Curry_Prelude.toCurryString "uacy") cd cs

nd_C_readAbstractCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_C_readAbstractCurryFile x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (System.Curry_Directory.d_C_doesFileExist x1 cd cs) s1 cd cs))
  (wrapNX id (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64 x1)) s3 cd
  cs))

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Curry_Prelude.d_C_readFile x2 cd cs) cd cs)
  (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61
  x2 x1) cd cs

nd_OP_readAbstractCurryFile_dot_readExistingACY_dot_98 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
nd_OP_readAbstractCurryFile_dot_readExistingACY_dot_98 x1 x2 s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (Curry_Prelude.d_C_readFile x2 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61
  x2 x1)) s3 cd cs))

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61 x1 x2 x3 cd cs =
  let x4 = x3
      x5 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id
        Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
        (Curry_Prelude.C_Char '\n'#)) cd cs) x4 cd cs
      x6 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1
        x5 cd cs
      x7 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines
        x5 cd cs
  in d_C__case_5 x6 x1 x7 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char x6
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) cd cs

nd_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
nd_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61 x1 x2 x3 s cd cs =
  let s6 = s
  in s6 `seq` (let s2 = leftSupply s6
                   s5 = rightSupply s6
  in s2 `seq` (s5 `seq` (let x4 = x3
                             x5 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_break (wrapNX id
                               (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                               (acceptCs id
                               Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char))
                               (Curry_Prelude.C_Char '\n'#))) s0 cd cs) x4 s1 cd
                               cs)
                             x6 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1
                               x5 cd cs
                             x7 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines
                               x5 cd cs
  in let s4 = leftSupply s5
         s3 = rightSupply s5
  in s4 `seq` (s3 `seq` nd_C__case_5 x6 x1 x7 x2
  (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char) x6
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) s3 cd cs) s4 cd cs))))

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1
    l cd cs)
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP5_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.98._#lambda61._#selFP5#line1"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.98._#lambda61._#selFP5#line1"
    (showCons x1))

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines
    l cd cs)
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_98_dot_uscore_hash_lambda61_dot_uscore_hash_selFP6_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.98._#lambda61._#selFP6#lines"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.98._#lambda61._#selFP6#lines"
    (showCons x1))

nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_readAbstractCurryFile_dot_readExistingACY_dot_98 (wrapNX
    id
    AbstractCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_AbstractCurry_dot_Types_dot_CurryProg)
    x1 s0 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let x3 = System.Curry_CurryPath.d_C_inCurrySubdir x1 cd cs
    in let s3 = leftSupply s4
           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_Directory.d_C_doesFileExist x3 cd cs) s1 cd cs))
    (wrapNX id
    (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64_dot_uscore_hash_lambda67
    x1 x3)) s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64 x1 l s cd cs)
    (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64 x1 e s cd $! addCs c
    cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda64" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda64" (showCons x2))

nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64_dot_uscore_hash_lambda67 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64_dot_uscore_hash_lambda67 x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_readAbstractCurryFile_dot_readExistingACY_dot_98 (wrapNX
    id
    AbstractCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_AbstractCurry_dot_Types_dot_CurryProg)
    x2 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "EXISTENCE ERROR: AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString
    "' does not exist") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64_dot_uscore_hash_lambda67
    x1 x2 l s cd cs)
    (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64_dot_uscore_hash_lambda67
    x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64_dot_uscore_hash_lambda67
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_readAbstractCurryFile_dot_uscore_hash_lambda64_dot_uscore_hash_lambda67
    x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda64._#lambda67" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda64._#lambda67" (showCons
    x3))

nd_C_tryReadACYFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C_tryReadACYFile x1 s cd cs = let s8 = s
  in s8 `seq` (let s2 = leftSupply s8
                   s7 = rightSupply s8
  in s2 `seq` (s7 `seq` (let x2 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
                               s0 cd cs) Curry_Prelude.C_Nothing s1 cd cs)
  in let s6 = leftSupply s7
         s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s3 cd cs) (System.Curry_Directory.d_C_doesFileExist x1 cd cs) s4 cd cs))
  (wrapNX id (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74 x1 x2)) s6 cd cs))))

nd_OP_tryReadACYFile_dot_tryRead_dot_109 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_tryRead_dot_109 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  s0 cd cs) (Curry_Prelude.d_C_readFile x3 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70 x1 x2)) s3
  cd cs))

nd_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70 x1 x2 x3 s cd cs =
  let s10 = s
  in s10 `seq` (let s2 = leftSupply s10
                    s9 = rightSupply s10
  in s2 `seq` (s9 `seq` (let x4 = x3
                             x5 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_break (wrapNX id
                               (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                               (acceptCs id
                               Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char))
                               (Curry_Prelude.C_Char '\n'#))) s0 cd cs) x4 s1 cd
                               cs)
                             x6 = d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP8_hash_line1
                               x5 cd cs
                             x7 = d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP9_hash_lines
                               x5 cd cs
  in let s8 = leftSupply s9
         s7 = rightSupply s9
  in s8 `seq` (s7 `seq` nd_C__case_4 x6 x7 x2 x1 (let s6 = leftSupply s7
                                                      s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char) s3
  cd cs) x6 s4 cd cs)) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "{- ") (Curry_Prelude.d_OP_plus_plus
  (AbstractCurry.Curry_Types.d_C_version cd cs) (Curry_Prelude.toCurryString
  " -}") cd cs) cd cs) s6 cd cs)) s8 cd cs))))

d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP8_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP8_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP8_hash_line1
    l cd cs)
    (d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP8_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP8_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP8_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.109._#lambda70._#selFP8#line1"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.109._#lambda70._#selFP8#line1"
    (showCons x1))

d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP9_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP9_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP9_hash_lines
    l cd cs)
    (d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP9_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP9_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_tryRead_dot_109_dot_uscore_hash_lambda70_dot_uscore_hash_selFP9_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.109._#lambda70._#selFP9#lines"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.109._#lambda70._#selFP9#lines"
    (showCons x1))

nd_OP_tryReadACYFile_dot_uscore_hash_lambda74 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_uscore_hash_lambda74 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tryReadACYFile_dot_tryRead_dot_109 x1 x2 x1 s0 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let x4 = System.Curry_CurryPath.d_C_inCurrySubdir x1 cd cs
    in let s3 = leftSupply s4
           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_Directory.d_C_doesFileExist x4 cd cs) s1 cd cs))
    (wrapNX id
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74_dot_uscore_hash_lambda77 x1
    x4 x2)) s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74 x1 x2 l s cd cs)
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadACYFile_dot_uscore_hash_lambda74 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74 x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda74" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files.tryReadACYFile._#lambda74"
    (showCons x3))

nd_OP_tryReadACYFile_dot_uscore_hash_lambda74_dot_uscore_hash_lambda77 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_uscore_hash_lambda74_dot_uscore_hash_lambda77 x1 x2 x3 x4 s cd cs =
  case x4 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tryReadACYFile_dot_tryRead_dot_109 x1 x3 x2 s0 cd cs
  Curry_Prelude.C_False -> x3
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74_dot_uscore_hash_lambda77 x1
    x2 x3 l s cd cs)
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74_dot_uscore_hash_lambda77 x1
    x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadACYFile_dot_uscore_hash_lambda74_dot_uscore_hash_lambda77 x1 x2
    x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda74_dot_uscore_hash_lambda77 x1
    x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda74._#lambda77" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile._#lambda74._#lambda77" (showCons x4))

nd_C_writeAbstractCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_writeAbstractCurryFile x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_writeFile x1 (Curry_ReadShowTerm.nd_C_showTerm
  (wrapNX id
  AbstractCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_AbstractCurry_dot_Types_dot_CurryProg)
  x2 s0 cd cs) cd cs

nd_C__case_20 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_20 x1 x3 x4 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_readCurryWithImports_dot_collect_dot_4 x1 x4 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_19 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_20 x1 x3 x4 l s
    cd cs) (nd_C__case_20 x1 x3 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_20 x1
    x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_20 x1 x3 x4 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_20" [show x1, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_20" (showCons x5))

nd_C__case_19 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_19 x4 x1 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (nd_C_readCurry x3 s1 cd cs) s2 cd cs)))) (wrapNX id
    (nd_OP_readCurryWithImports_dot_collect_dot_4_dot_uscore_hash_lambda3 x3 x1
    x4)) s5 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_19 x4 x1 x3 l s
    cd cs) (nd_C__case_19 x4 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_19 x4
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_19 x4 x1 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_19" [show x4, show x1, show x3, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_19" (showCons x5))

nd_C__case_18 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
nd_C__case_18 x1 x3 x4 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tryReadCurryWithImports_dot_collect_dot_13 x1 x4 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_17 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_18 x1 x3 x4 l s
    cd cs) (nd_C__case_18 x1 x3 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_18 x1
    x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_18 x1 x3 x4 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_18" [show x1, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_18" (showCons x5))

nd_C__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
nd_C__case_17 x4 x1 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (nd_C_tryReadCurryFile x3 s1 cd cs) s2 cd cs)))) (wrapNX id
    (nd_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8 x3
    x1 x4)) s5 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_17 x4 x1 x3 l s
    cd cs) (nd_C__case_17 x4 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_17 x4
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_17 x4 x1 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_17" [show x4, show x1, show x3, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_17" (showCons x5))

nd_C__case_16 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CurryProg))
nd_C__case_16 x3 x2 x1 x6 s cd cs = case x6 of
  AbstractCurry.Curry_Types.C_CurryProg x7 x8 x9 x10 x11 x12 x13 x14 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (nd_OP_tryReadCurryWithImports_dot_collect_dot_13
    (Curry_Prelude.OP_Cons x1 x2) (Curry_Prelude.d_OP_plus_plus x3 x8 cd cs) s1
    cd cs) s2 cd cs)))) (wrapDX id
    (d_OP_tryReadCurryWithImports_dot_collect_dot_13_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x6)) s5 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CurryProg d i l r -> narrow d i
    (nd_C__case_16 x3 x2 x1 l s cd cs) (nd_C__case_16 x3 x2 x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CurryProg d i xs -> narrows cs d i (\z ->
    nd_C__case_16 x3 x2 x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CurryProg d c e -> guardCons d c
    (nd_C__case_16 x3 x2 x1 e s cd $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CurryProg d info -> failCons d (traceFail
    "AbstractCurry.Files._case_16" [show x3, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_16" (showCons x6))

nd_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_15 x1 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s15 = s
    in s15 `seq` (let s14 = leftSupply s15
                      s16 = rightSupply s15
                      s2 = leftSupply s16
                      s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s2 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_FrontendExec.d_C_callFrontendWithParams
    System.Curry_FrontendExec.C_ACY (System.Curry_FrontendExec.d_C_setQuiet
    Curry_Prelude.C_True (System.Curry_FrontendExec.d_C_defaultParams cd cs) cd
    cs) x1 cd cs) s1 cd cs)) (let s12 = leftSupply s13
                                  s10 = rightSupply s13
    in s12 `seq` (s10 `seq` Curry_Prelude.nd_C_apply (let s9 = leftSupply s10
                                                          s11 = rightSupply s10
                                                          s3 = leftSupply s11
                                                          s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s3 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s3 cd cs) (let s7 = leftSupply s8
                   s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s4 cd cs) (System.Curry_CurryPath.d_C_getLoadPathForModule x1 cd cs) s5 cd
    cs)) (wrapDX id (System.Curry_Directory.d_C_findFileWithSuffix
    (d_C_abstractCurryFileName x1 cd cs) (Curry_Prelude.OP_Cons
    Curry_Prelude.OP_List Curry_Prelude.OP_List))) s7 cd cs)) s9 cd cs))))
    (wrapNX id
    (nd_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19 x1
    x5)) s12 cd cs)) s14 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_15 x1 l s cd
    cs) (nd_C__case_15 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_15
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_15 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_15" [show x1, show x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_15" (showCons x3))

nd_C__case_14 :: Data.Curry_Time.C_ClockTime -> Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_14 x5 x1 x2 x3 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (nd_OP_tryReadCurryFile_dot_cancel_dot_33 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Source file '")
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "' is newer than AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd
    cs) cd cs) cd cs) s0 cd cs
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (nd_C_tryParse x2 s1 cd cs) s2 cd cs)))) (wrapDX id
    d_OP_tryReadCurryFile_dot_uscore_hash_lambda15_dot_uscore_hash_lambda19_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29)
    s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_14 x5 x1 x2 x3 l
    s cd cs) (nd_C__case_14 x5 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_14 x5
    x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_14 x5 x1 x2 x3 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_14" [show x5, show x1, show x2, show x3, show x6]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_14" (showCons x6))

nd_C__case_13 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_13 x3 x1 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (nd_OP_tryParse_dot_cancel_dot_55 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry file '") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "' does not exist") cd cs) cd cs) s0 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (Curry_Prelude.d_C_readFile x1 cd cs) s1 cd cs)) (wrapNX id
    (nd_OP_tryParse_dot_uscore_hash_lambda33_dot_uscore_hash_lambda36 x1)) s3 cd
    cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_13 x3 x1 l s cd
    cs) (nd_C__case_13 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_13 x3
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_13 x3 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_13" [show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_13" (showCons x4))

nd_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_12 x5 x6 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (nd_OP_tryParse_dot_cancel_dot_55 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Could not parse AbstractCurry file '") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "': incompatible versions") cd cs) cd cs) s0 cd
    cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` (let x7 = Curry_ReadShowTerm.nd_C_readsUnqualifiedTerm (wrapNX
                       id
                       AbstractCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_AbstractCurry_dot_Types_dot_CurryProg)
                       (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "AbstractCurry.Types") (Curry_Prelude.OP_Cons
                       (Curry_Prelude.toCurryString "Prelude")
                       Curry_Prelude.OP_List)) x6 s0 cd cs
    in d_C__case_11 x1 x7 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_12 x5 x6 x1 l s
    cd cs) (nd_C__case_12 x5 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_12 x5
    x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_12 x5 x6 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_12" [show x5, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_12" (showCons x8))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_11 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_10 x9 x1 x8 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar
    (d_OP_tryParse_dot_cancel_dot_55
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Could not parse AbstractCurry file '") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "': no parse") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_11 x1 l cd cs)
    (d_C__case_11 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_11 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_11 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_11" [show x1, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_11" (showCons x7))

d_C__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CurryProg
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_10 x9 x1 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> d_C__case_9 x1 x11 x10 x9 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_10 x9 x1 l cd
    cs) (d_C__case_10 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_10
    x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_10 x9 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_10" [show x9, show x1, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_10" (showCons x8))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CurryProg
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_9 x1 x11 x10 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> d_C__case_8 x11 x1 x10 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all Curry_Prelude.d_C_isSpace cd cs) x11 cd cs) cd cs
  Curry_Prelude.OP_Cons x12 x13 -> Curry_Prelude.d_OP_dollar
    (d_OP_tryParse_dot_cancel_dot_55
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Could not parse AbstractCurry file '") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "': no parse") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 x1 x11 x10 l
    cd cs) (d_C__case_9 x1 x11 x10 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 x1
    x11 x10 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_9 x1 x11 x10 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_9" [show x1, show x11, show x10, show x9] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_9" (showCons x9))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_8 x11 x1 x10 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (Curry_Prelude.C_Right x10) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    (d_OP_tryParse_dot_cancel_dot_55
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Could not parse AbstractCurry file '") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "': no parse") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x11 x1 x10 l cd
    cs) (d_C__case_8 x11 x1 x10 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x11
    x1 x10 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_8 x11 x1 x10 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_8" [show x11, show x1, show x10, show x12] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_8" (showCons x12))

nd_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> System.Curry_FrontendExec.C_FrontendParams -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_C__case_7 x2 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s2 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_FrontendExec.d_C_callFrontendWithParams
    System.Curry_FrontendExec.C_ACY x1 x3 cd cs) s1 cd cs)) (let s6 = leftSupply
                                                                   s7
                                                                 s5 = rightSupply
                                                                   s7
    in s6 `seq` (s5 `seq` nd_C_readAbstractCurryFile (d_C_abstractCurryFileName
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id) (System.Curry_FilePath.d_OP_lt_slash_gt cd cs)) x6 s3 cd
    cs) x2 s4 cd cs)) cd cs) s6 cd cs)) s8 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_7 x2 x3 x1 l
    s cd cs) (nd_C__case_7 x2 x3 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_7
    x2 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_7 x2 x3 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_7" [show x2, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_7" (showCons x5))

nd_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> System.Curry_FrontendExec.C_FrontendParams -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
nd_C__case_6 x2 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s2 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (System.Curry_FrontendExec.d_C_callFrontendWithParams
    System.Curry_FrontendExec.C_UACY x1 x3 cd cs) s1 cd cs))
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` nd_C_readAbstractCurryFile
    (d_C_untypedAbstractCurryFileName (let s4 = leftSupply s5
                                           s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id) (System.Curry_FilePath.d_OP_lt_slash_gt cd cs)) x6 s3 cd
    cs) x2 s4 cd cs)) cd cs) s6 cd cs)) s8 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_6 x2 x3 x1 l
    s cd cs) (nd_C__case_6 x2 x3 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_6
    x2 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_6 x2 x3 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_6" [show x2, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_6" (showCons x5))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_C__case_5 x6 x1 x7 x2 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (Curry_ReadShowTerm.d_C_readUnqualifiedTerm x2 (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "AbstractCurry.Types") (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "Prelude") Curry_Prelude.OP_List)) x7 cd cs) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x6 x1 x7 x2 l
    cd cs) (d_C__case_5 x6 x1 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x6 x1
    x7 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_5 x6 x1 x7 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_5" [show x6, show x1, show x7, show x2, show x8]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_5" (showCons x8))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
nd_C__case_5 x6 x1 x7 x2 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (Curry_ReadShowTerm.nd_C_readUnqualifiedTerm x2
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "AbstractCurry.Types")
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    Curry_Prelude.OP_List)) x7 s1 cd cs) s2 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_error)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x1 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_5 x6 x1 x7 x2 l
    s cd cs) (nd_C__case_5 x6 x1 x7 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_5 x6
    x1 x7 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_5 x6 x1 x7 x2 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_5" [show x6, show x1, show x7, show x2, show x8]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_5" (showCons x8))

nd_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_4 x6 x7 x2 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_error)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x1 cd cs) s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_3 x7 x2
    (Curry_ReadShowTerm.nd_C_readsUnqualifiedTerm (wrapNX id
    AbstractCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_AbstractCurry_dot_Types_dot_CurryProg)
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "AbstractCurry.Types")
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    Curry_Prelude.OP_List)) x7 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x6 x7 x2 x1 l
    s cd cs) (nd_C__case_4 x6 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x6
    x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_4 x6 x7 x2 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_4" [show x6, show x7, show x2, show x1, show x8]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_4" (showCons x8))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_3 x7 x2 x10 cd cs = case x10 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_2 x9 x2 x8 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x7 x2 l cd cs)
    (d_C__case_3 x7 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x7
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_3 x7 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_3" [show x7, show x2, show x10] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_3" (showCons x10))

nd_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_3 x7 x2 x10 s cd cs = case x10 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_2 x9 x2 x8 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_3 x7 x2 l s cd
    cs) (nd_C__case_3 x7 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_3 x7
    x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_3 x7 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_3" [show x7, show x2, show x10] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_3" (showCons x10))

d_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_2 x9 x2 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> d_C__case_1 x2 x11 x10 x9 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_2 x9 x2 l cd
    cs) (d_C__case_2 x9 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_2 x9
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_2 x9 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_2" [show x9, show x2, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_2" (showCons x8))

nd_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_2 x9 x2 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> let s0 = s
    in s0 `seq` nd_C__case_1 x2 x11 x10 x9 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_2 x9 x2 l s
    cd cs) (nd_C__case_2 x9 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_2
    x9 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_2 x9 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_2" [show x9, show x2, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_2" (showCons x8))

d_C__case_1 :: Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_1 x2 x11 x10 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> d_C__case_0 x11 x2 x10 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all Curry_Prelude.d_C_isSpace cd cs) x11 cd cs) cd cs
  Curry_Prelude.OP_Cons x12 x13 -> x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 x2 x11 x10 l
    cd cs) (d_C__case_1 x2 x11 x10 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 x2
    x11 x10 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_1 x2 x11 x10 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_1" [show x2, show x11, show x10, show x9] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_1" (showCons x9))

nd_C__case_1 :: Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_1 x2 x11 x10 x9 s cd cs = case x9 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_0 x11 x2 x10 (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all
    (wrapDX id Curry_Prelude.d_C_isSpace) s0 cd cs) x11 s1 cd cs)) s3 cd cs))
  Curry_Prelude.OP_Cons x12 x13 -> x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_1 x2 x11 x10 l
    s cd cs) (nd_C__case_1 x2 x11 x10 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_1 x2
    x11 x10 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_1 x2 x11 x10 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_1" [show x2, show x11, show x10, show x9] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_1" (showCons x9))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_0 x11 x2 x10 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (Curry_Prelude.C_Just x10) cd cs
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x11 x2 x10 l cd
    cs) (d_C__case_0 x11 x2 x10 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x11
    x2 x10 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_0 x11 x2 x10 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_0" [show x11, show x2, show x10, show x12] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_0" (showCons x12))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_0 x11 x2 x10 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    s0 cd cs) (Curry_Prelude.C_Just x10) s1 cd cs))
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x11 x2 x10 l s
    cd cs) (nd_C__case_0 x11 x2 x10 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x11
    x2 x10 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_0 x11 x2 x10 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_0" [show x11, show x2, show x10, show x12] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_0" (showCons x12))

